package com.abi.qms.platform;

import cn.hutool.crypto.SecureUtil;
import cn.hutool.crypto.symmetric.AES;
import com.abi.qms.platform.infrastructure.util.AesEncodeUtil;
import com.abi.task.common.api.exception.BusinessException;
import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;
import lombok.extern.slf4j.Slf4j;

import java.io.*;

/**
 * 测试加解密方法
 */
@Slf4j
public class EncryptionTest {
    static final String key = "EC/Z+S7c3EFJa2dtvLyekg==";

    /**
     * 加密
     *
     * @param data
     * @param key
     * @return
     * @throws Exception
     */
    public static String encryptAES(String data, String key) {
        byte[] keyByte = Base64.decode(key);
        AES aes = SecureUtil.aes(keyByte);
        byte[] encryptData = aes.encrypt(data);   //加密
        String encryptDataEncode = Base64.encode(encryptData);
        return encryptDataEncode;
    }




    /**
     * 写入文件
     *
     * @param name
     * @param path
     * @throws IOException
     */
    public static void getFile(String name, String path) throws IOException {
        Writer writer = new FileWriter(path, true);
        BufferedWriter buff = null;
        try {
            buff = new BufferedWriter(writer);
            buff.write(name);
            buff.newLine();
            buff.flush();
        }finally {
            if (null != buff){
                buff.close();
            }
        }
    }


    public static void main(String[] args) {
        String key = "EC/Z+S7c3EFJa2dtvLyekg==";
        // 单个字符串解码
        // String content = "aLI5iXza3R/w7aJ2AsYhUT7EGS0Zqk94k1nXK9rT8AvJGMbMUJytae53f82pFphWy0bmnEGv4fWb6RcpE9m3tQ==";
        // 文件解码
        String content = readToString("D:\\whole.txt");
        String decodeStr = AesEncodeUtil.aesDecode(content, key);
        System.out.println(decodeStr);
    }


    /**
     * 读取文件
     *
     * @param fileName
     * @return
     */
    private static String readToString(String fileName) {
        String encoding = "UTF-8";
        File file = new File(fileName);
        Long fileLength = file.length();
        byte[] fileContent = new byte[fileLength.intValue()];
        FileInputStream in = null;
        try {
            in = new FileInputStream(file);
            in.read(fileContent);
        } catch (Exception e) {
            System.out.println(e);
        }finally {
            try {
                in.close();
            } catch (IOException e) {
                System.out.println(e);
            }
        }

        try {
            return new String(fileContent, encoding);
        } catch (UnsupportedEncodingException e) {
            System.err.println("The OS does not support " + encoding);
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 解密
     *
     * @param data
     * @param key
     * @return
     * @throws Exception
     */
    public static String jmencryptAES(String data, String key) {
        byte[] data2 = Base64.decode(data);
        byte[] key2 = Base64.decode(key);
        AES aes2 = SecureUtil.aes(key2);
        byte[] decrypt = aes2.decrypt(data2);
        return new String(decrypt);
    }
}

